/*
 *  Copyright (c) 2017-present, Facebook, Inc.
 *
 *  This source code is licensed under the MIT license found in the LICENSE
 *  file in the root directory of this source tree.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
#pragma once

#include <memory>
#include <string>
#include <utility>

#include <folly/Optional.h>
#include <folly/io/IOBuf.h>
#include <mcrouter/lib/carbon/CarbonProtocolReader.h>
#include <mcrouter/lib/carbon/CommonSerializationTraits.h>
#include <mcrouter/lib/carbon/Keys.h>
#include <mcrouter/lib/carbon/ReplyCommon.h>
#include <mcrouter/lib/carbon/RequestCommon.h>
#include <mcrouter/lib/carbon/RequestReplyUtil.h>
#include <mcrouter/lib/carbon/Result.h>
#include <mcrouter/lib/carbon/TypeList.h>
#include <mcrouter/lib/carbon/Variant.h>

#include "mcrouter/lib/network/gen/gen-cpp2/Memcache_types.h"

#include "mcrouter/lib/network/gen/CommonMessages.h"

namespace facebook {
namespace memcache {

class McGetReply;

class McGetRequest : public carbon::RequestCommon {
 public:
  using reply_type = McGetReply;

  static constexpr size_t typeId = 1;
  static constexpr const char* name = "get";

  McGetRequest() = default;
  McGetRequest(const McGetRequest&) = default;
  McGetRequest& operator=(const McGetRequest&) = default;
  McGetRequest(McGetRequest&&) = default;
  McGetRequest& operator=(McGetRequest&&) = default;
  explicit McGetRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McGetRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  const facebook::memcache::thrift::McGetRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McGetRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McGetRequest>;

 private:
  struct __isset {
    bool key;
    bool flags;
  } __isset = {};

  facebook::memcache::thrift::McGetRequest underlyingThriftStruct_;
};

class McGetReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 2;

  McGetReply() = default;
  McGetReply(const McGetReply&) = default;
  McGetReply& operator=(const McGetReply&) = default;
  McGetReply(McGetReply&&) = default;
  McGetReply& operator=(McGetReply&&) = default;
  explicit McGetReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::optional_field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McGetReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McGetReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McGetReply>;

 private:
  struct __isset {
    bool result;
    bool value;
    bool flags;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McGetReply underlyingThriftStruct_;
};

class McSetReply;

class McSetRequest : public carbon::RequestCommon {
 public:
  using reply_type = McSetReply;

  static constexpr size_t typeId = 3;
  static constexpr const char* name = "set";

  McSetRequest() = default;
  McSetRequest(const McSetRequest&) = default;
  McSetRequest& operator=(const McSetRequest&) = default;
  McSetRequest(McSetRequest&&) = default;
  McSetRequest& operator=(McSetRequest&&) = default;
  explicit McSetRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McSetRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  const facebook::memcache::thrift::McSetRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McSetRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McSetRequest>;

 private:
  struct __isset {
    bool key;
    bool exptime;
    bool flags;
    bool value;
  } __isset = {};

  facebook::memcache::thrift::McSetRequest underlyingThriftStruct_;
};

class McSetReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 4;

  McSetReply() = default;
  McSetReply(const McSetReply&) = default;
  McSetReply& operator=(const McSetReply&) = default;
  McSetReply(McSetReply&&) = default;
  McSetReply& operator=(McSetReply&&) = default;
  explicit McSetReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McSetReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McSetReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McSetReply>;

 private:
  struct __isset {
    bool result;
    bool flags;
    bool value;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McSetReply underlyingThriftStruct_;
};

class McDeleteReply;

class McDeleteRequest : public carbon::RequestCommon {
 public:
  using reply_type = McDeleteReply;

  static constexpr size_t typeId = 5;
  static constexpr const char* name = "delete";

  McDeleteRequest() = default;
  McDeleteRequest(const McDeleteRequest&) = default;
  McDeleteRequest& operator=(const McDeleteRequest&) = default;
  McDeleteRequest(McDeleteRequest&&) = default;
  McDeleteRequest& operator=(McDeleteRequest&&) = default;
  explicit McDeleteRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McDeleteRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::unordered_map<std::string, uint64_t>&>
   attributes_ref() const& {
    return underlyingThriftStruct_.attributes_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::unordered_map<std::string, uint64_t>&>
   attributes_ref() & {
    return underlyingThriftStruct_.attributes_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::unordered_map<std::string, uint64_t>&&>
   attributes_ref() && {
    return std::move(underlyingThriftStruct_).attributes_ref();
  }
  
  const facebook::memcache::thrift::McDeleteRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McDeleteRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McDeleteRequest>;

 private:
  struct __isset {
    bool key;
    bool flags;
    bool exptime;
    bool value;
    bool attributes;
  } __isset = {};

  facebook::memcache::thrift::McDeleteRequest underlyingThriftStruct_;
};

class McDeleteReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 6;

  McDeleteReply() = default;
  McDeleteReply(const McDeleteReply&) = default;
  McDeleteReply& operator=(const McDeleteReply&) = default;
  McDeleteReply(McDeleteReply&&) = default;
  McDeleteReply& operator=(McDeleteReply&&) = default;
  explicit McDeleteReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McDeleteReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McDeleteReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McDeleteReply>;

 private:
  struct __isset {
    bool result;
    bool flags;
    bool value;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McDeleteReply underlyingThriftStruct_;
};

class McLeaseGetReply;

class McLeaseGetRequest : public carbon::RequestCommon {
 public:
  using reply_type = McLeaseGetReply;

  static constexpr size_t typeId = 7;
  static constexpr const char* name = "lease-get";

  McLeaseGetRequest() = default;
  McLeaseGetRequest(const McLeaseGetRequest&) = default;
  McLeaseGetRequest& operator=(const McLeaseGetRequest&) = default;
  McLeaseGetRequest(McLeaseGetRequest&&) = default;
  McLeaseGetRequest& operator=(McLeaseGetRequest&&) = default;
  explicit McLeaseGetRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McLeaseGetRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  const facebook::memcache::thrift::McLeaseGetRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McLeaseGetRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McLeaseGetRequest>;

 private:
  struct __isset {
    bool key;
    bool flags;
  } __isset = {};

  facebook::memcache::thrift::McLeaseGetRequest underlyingThriftStruct_;
};

class McLeaseGetReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 8;

  McLeaseGetReply() = default;
  McLeaseGetReply(const McLeaseGetReply&) = default;
  McLeaseGetReply& operator=(const McLeaseGetReply&) = default;
  McLeaseGetReply(McLeaseGetReply&&) = default;
  McLeaseGetReply& operator=(McLeaseGetReply&&) = default;
  explicit McLeaseGetReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int64_t&>
   leaseToken_ref() const& {
    return underlyingThriftStruct_.leaseToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&>
   leaseToken_ref() & {
    return underlyingThriftStruct_.leaseToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&&>
   leaseToken_ref() && {
    return std::move(underlyingThriftStruct_).leaseToken_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::optional_field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McLeaseGetReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McLeaseGetReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McLeaseGetReply>;

 private:
  struct __isset {
    bool result;
    bool leaseToken;
    bool value;
    bool flags;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McLeaseGetReply underlyingThriftStruct_;
};

class McLeaseSetReply;

class McLeaseSetRequest : public carbon::RequestCommon {
 public:
  using reply_type = McLeaseSetReply;

  static constexpr size_t typeId = 9;
  static constexpr const char* name = "lease-set";

  McLeaseSetRequest() = default;
  McLeaseSetRequest(const McLeaseSetRequest&) = default;
  McLeaseSetRequest& operator=(const McLeaseSetRequest&) = default;
  McLeaseSetRequest(McLeaseSetRequest&&) = default;
  McLeaseSetRequest& operator=(McLeaseSetRequest&&) = default;
  explicit McLeaseSetRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McLeaseSetRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int64_t&>
   leaseToken_ref() const& {
    return underlyingThriftStruct_.leaseToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&>
   leaseToken_ref() & {
    return underlyingThriftStruct_.leaseToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&&>
   leaseToken_ref() && {
    return std::move(underlyingThriftStruct_).leaseToken_ref();
  }
  
  const facebook::memcache::thrift::McLeaseSetRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McLeaseSetRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McLeaseSetRequest>;

 private:
  struct __isset {
    bool key;
    bool exptime;
    bool flags;
    bool value;
    bool leaseToken;
  } __isset = {};

  facebook::memcache::thrift::McLeaseSetRequest underlyingThriftStruct_;
};

class McLeaseSetReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 10;

  McLeaseSetReply() = default;
  McLeaseSetReply(const McLeaseSetReply&) = default;
  McLeaseSetReply& operator=(const McLeaseSetReply&) = default;
  McLeaseSetReply(McLeaseSetReply&&) = default;
  McLeaseSetReply& operator=(McLeaseSetReply&&) = default;
  explicit McLeaseSetReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McLeaseSetReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McLeaseSetReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McLeaseSetReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McLeaseSetReply underlyingThriftStruct_;
};

class McAddReply;

class McAddRequest : public carbon::RequestCommon {
 public:
  using reply_type = McAddReply;

  static constexpr size_t typeId = 11;
  static constexpr const char* name = "add";

  McAddRequest() = default;
  McAddRequest(const McAddRequest&) = default;
  McAddRequest& operator=(const McAddRequest&) = default;
  McAddRequest(McAddRequest&&) = default;
  McAddRequest& operator=(McAddRequest&&) = default;
  explicit McAddRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McAddRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  const facebook::memcache::thrift::McAddRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McAddRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McAddRequest>;

 private:
  struct __isset {
    bool key;
    bool exptime;
    bool flags;
    bool value;
  } __isset = {};

  facebook::memcache::thrift::McAddRequest underlyingThriftStruct_;
};

class McAddReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 12;

  McAddReply() = default;
  McAddReply(const McAddReply&) = default;
  McAddReply& operator=(const McAddReply&) = default;
  McAddReply(McAddReply&&) = default;
  McAddReply& operator=(McAddReply&&) = default;
  explicit McAddReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McAddReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McAddReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McAddReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McAddReply underlyingThriftStruct_;
};

class McReplaceReply;

class McReplaceRequest : public carbon::RequestCommon {
 public:
  using reply_type = McReplaceReply;

  static constexpr size_t typeId = 13;
  static constexpr const char* name = "replace";

  McReplaceRequest() = default;
  McReplaceRequest(const McReplaceRequest&) = default;
  McReplaceRequest& operator=(const McReplaceRequest&) = default;
  McReplaceRequest(McReplaceRequest&&) = default;
  McReplaceRequest& operator=(McReplaceRequest&&) = default;
  explicit McReplaceRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McReplaceRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  const facebook::memcache::thrift::McReplaceRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McReplaceRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McReplaceRequest>;

 private:
  struct __isset {
    bool key;
    bool exptime;
    bool flags;
    bool value;
  } __isset = {};

  facebook::memcache::thrift::McReplaceRequest underlyingThriftStruct_;
};

class McReplaceReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 14;

  McReplaceReply() = default;
  McReplaceReply(const McReplaceReply&) = default;
  McReplaceReply& operator=(const McReplaceReply&) = default;
  McReplaceReply(McReplaceReply&&) = default;
  McReplaceReply& operator=(McReplaceReply&&) = default;
  explicit McReplaceReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McReplaceReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McReplaceReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McReplaceReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McReplaceReply underlyingThriftStruct_;
};

class McGetsReply;

class McGetsRequest : public carbon::RequestCommon {
 public:
  using reply_type = McGetsReply;

  static constexpr size_t typeId = 15;
  static constexpr const char* name = "gets";

  McGetsRequest() = default;
  McGetsRequest(const McGetsRequest&) = default;
  McGetsRequest& operator=(const McGetsRequest&) = default;
  McGetsRequest(McGetsRequest&&) = default;
  McGetsRequest& operator=(McGetsRequest&&) = default;
  explicit McGetsRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McGetsRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  const facebook::memcache::thrift::McGetsRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McGetsRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McGetsRequest>;

 private:
  struct __isset {
    bool key;
    bool flags;
  } __isset = {};

  facebook::memcache::thrift::McGetsRequest underlyingThriftStruct_;
};

class McGetsReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 16;

  McGetsReply() = default;
  McGetsReply(const McGetsReply&) = default;
  McGetsReply& operator=(const McGetsReply&) = default;
  McGetsReply(McGetsReply&&) = default;
  McGetsReply& operator=(McGetsReply&&) = default;
  explicit McGetsReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   casToken_ref() const& {
    return underlyingThriftStruct_.casToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   casToken_ref() & {
    return underlyingThriftStruct_.casToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   casToken_ref() && {
    return std::move(underlyingThriftStruct_).casToken_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::optional_field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McGetsReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McGetsReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McGetsReply>;

 private:
  struct __isset {
    bool result;
    bool casToken;
    bool value;
    bool flags;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McGetsReply underlyingThriftStruct_;
};

class McCasReply;

class McCasRequest : public carbon::RequestCommon {
 public:
  using reply_type = McCasReply;

  static constexpr size_t typeId = 17;
  static constexpr const char* name = "cas";

  McCasRequest() = default;
  McCasRequest(const McCasRequest&) = default;
  McCasRequest& operator=(const McCasRequest&) = default;
  McCasRequest(McCasRequest&&) = default;
  McCasRequest& operator=(McCasRequest&&) = default;
  explicit McCasRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McCasRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   casToken_ref() const& {
    return underlyingThriftStruct_.casToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   casToken_ref() & {
    return underlyingThriftStruct_.casToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   casToken_ref() && {
    return std::move(underlyingThriftStruct_).casToken_ref();
  }
  
  const facebook::memcache::thrift::McCasRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McCasRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McCasRequest>;

 private:
  struct __isset {
    bool key;
    bool exptime;
    bool flags;
    bool value;
    bool casToken;
  } __isset = {};

  facebook::memcache::thrift::McCasRequest underlyingThriftStruct_;
};

class McCasReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 18;

  McCasReply() = default;
  McCasReply(const McCasReply&) = default;
  McCasReply& operator=(const McCasReply&) = default;
  McCasReply(McCasReply&&) = default;
  McCasReply& operator=(McCasReply&&) = default;
  explicit McCasReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McCasReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McCasReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McCasReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McCasReply underlyingThriftStruct_;
};

class McIncrReply;

class McIncrRequest : public carbon::RequestCommon {
 public:
  using reply_type = McIncrReply;

  static constexpr size_t typeId = 19;
  static constexpr const char* name = "incr";

  McIncrRequest() = default;
  McIncrRequest(const McIncrRequest&) = default;
  McIncrRequest& operator=(const McIncrRequest&) = default;
  McIncrRequest(McIncrRequest&&) = default;
  McIncrRequest& operator=(McIncrRequest&&) = default;
  explicit McIncrRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McIncrRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int64_t&>
   delta_ref() const& {
    return underlyingThriftStruct_.delta_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&>
   delta_ref() & {
    return underlyingThriftStruct_.delta_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&&>
   delta_ref() && {
    return std::move(underlyingThriftStruct_).delta_ref();
  }
  
  const facebook::memcache::thrift::McIncrRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McIncrRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McIncrRequest>;

 private:
  struct __isset {
    bool key;
    bool delta;
  } __isset = {};

  facebook::memcache::thrift::McIncrRequest underlyingThriftStruct_;
};

class McIncrReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 20;

  McIncrReply() = default;
  McIncrReply(const McIncrReply&) = default;
  McIncrReply& operator=(const McIncrReply&) = default;
  McIncrReply(McIncrReply&&) = default;
  McIncrReply& operator=(McIncrReply&&) = default;
  explicit McIncrReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int64_t&>
   delta_ref() const& {
    return underlyingThriftStruct_.delta_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&>
   delta_ref() & {
    return underlyingThriftStruct_.delta_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&&>
   delta_ref() && {
    return std::move(underlyingThriftStruct_).delta_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McIncrReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McIncrReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McIncrReply>;

 private:
  struct __isset {
    bool result;
    bool delta;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McIncrReply underlyingThriftStruct_;
};

class McDecrReply;

class McDecrRequest : public carbon::RequestCommon {
 public:
  using reply_type = McDecrReply;

  static constexpr size_t typeId = 21;
  static constexpr const char* name = "decr";

  McDecrRequest() = default;
  McDecrRequest(const McDecrRequest&) = default;
  McDecrRequest& operator=(const McDecrRequest&) = default;
  McDecrRequest(McDecrRequest&&) = default;
  McDecrRequest& operator=(McDecrRequest&&) = default;
  explicit McDecrRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McDecrRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int64_t&>
   delta_ref() const& {
    return underlyingThriftStruct_.delta_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&>
   delta_ref() & {
    return underlyingThriftStruct_.delta_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&&>
   delta_ref() && {
    return std::move(underlyingThriftStruct_).delta_ref();
  }
  
  const facebook::memcache::thrift::McDecrRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McDecrRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McDecrRequest>;

 private:
  struct __isset {
    bool key;
    bool delta;
  } __isset = {};

  facebook::memcache::thrift::McDecrRequest underlyingThriftStruct_;
};

class McDecrReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 22;

  McDecrReply() = default;
  McDecrReply(const McDecrReply&) = default;
  McDecrReply& operator=(const McDecrReply&) = default;
  McDecrReply(McDecrReply&&) = default;
  McDecrReply& operator=(McDecrReply&&) = default;
  explicit McDecrReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int64_t&>
   delta_ref() const& {
    return underlyingThriftStruct_.delta_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&>
   delta_ref() & {
    return underlyingThriftStruct_.delta_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int64_t&&>
   delta_ref() && {
    return std::move(underlyingThriftStruct_).delta_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McDecrReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McDecrReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McDecrReply>;

 private:
  struct __isset {
    bool result;
    bool delta;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McDecrReply underlyingThriftStruct_;
};

class McMetagetReply;

class McMetagetRequest : public carbon::RequestCommon {
 public:
  using reply_type = McMetagetReply;

  static constexpr size_t typeId = 23;
  static constexpr const char* name = "metaget";

  McMetagetRequest() = default;
  McMetagetRequest(const McMetagetRequest&) = default;
  McMetagetRequest& operator=(const McMetagetRequest&) = default;
  McMetagetRequest(McMetagetRequest&&) = default;
  McMetagetRequest& operator=(McMetagetRequest&&) = default;
  explicit McMetagetRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McMetagetRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  const facebook::memcache::thrift::McMetagetRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McMetagetRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McMetagetRequest>;

 private:
  struct __isset {
    bool key;
  } __isset = {};

  facebook::memcache::thrift::McMetagetRequest underlyingThriftStruct_;
};

class McMetagetReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 24;

  McMetagetReply() = default;
  McMetagetReply(const McMetagetReply&) = default;
  McMetagetReply& operator=(const McMetagetReply&) = default;
  McMetagetReply(McMetagetReply&&) = default;
  McMetagetReply& operator=(McMetagetReply&&) = default;
  explicit McMetagetReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   age_ref() const& {
    return underlyingThriftStruct_.age_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   age_ref() & {
    return underlyingThriftStruct_.age_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   age_ref() && {
    return std::move(underlyingThriftStruct_).age_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   ipv_ref() const& {
    return underlyingThriftStruct_.ipv_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   ipv_ref() & {
    return underlyingThriftStruct_.ipv_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   ipv_ref() && {
    return std::move(underlyingThriftStruct_).ipv_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   ipAddress_ref() const& {
    return underlyingThriftStruct_.ipAddress_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   ipAddress_ref() & {
    return underlyingThriftStruct_.ipAddress_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   ipAddress_ref() && {
    return std::move(underlyingThriftStruct_).ipAddress_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McMetagetReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McMetagetReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McMetagetReply>;

 private:
  struct __isset {
    bool result;
    bool age;
    bool exptime;
    bool ipv;
    bool ipAddress;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McMetagetReply underlyingThriftStruct_;
};

class McAppendReply;

class McAppendRequest : public carbon::RequestCommon {
 public:
  using reply_type = McAppendReply;

  static constexpr size_t typeId = 27;
  static constexpr const char* name = "append";

  McAppendRequest() = default;
  McAppendRequest(const McAppendRequest&) = default;
  McAppendRequest& operator=(const McAppendRequest&) = default;
  McAppendRequest(McAppendRequest&&) = default;
  McAppendRequest& operator=(McAppendRequest&&) = default;
  explicit McAppendRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McAppendRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  const facebook::memcache::thrift::McAppendRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McAppendRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McAppendRequest>;

 private:
  struct __isset {
    bool key;
    bool exptime;
    bool flags;
    bool value;
  } __isset = {};

  facebook::memcache::thrift::McAppendRequest underlyingThriftStruct_;
};

class McAppendReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 28;

  McAppendReply() = default;
  McAppendReply(const McAppendReply&) = default;
  McAppendReply& operator=(const McAppendReply&) = default;
  McAppendReply(McAppendReply&&) = default;
  McAppendReply& operator=(McAppendReply&&) = default;
  explicit McAppendReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McAppendReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McAppendReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McAppendReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McAppendReply underlyingThriftStruct_;
};

class McPrependReply;

class McPrependRequest : public carbon::RequestCommon {
 public:
  using reply_type = McPrependReply;

  static constexpr size_t typeId = 29;
  static constexpr const char* name = "prepend";

  McPrependRequest() = default;
  McPrependRequest(const McPrependRequest&) = default;
  McPrependRequest& operator=(const McPrependRequest&) = default;
  McPrependRequest(McPrependRequest&&) = default;
  McPrependRequest& operator=(McPrependRequest&&) = default;
  explicit McPrependRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McPrependRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  const facebook::memcache::thrift::McPrependRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McPrependRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McPrependRequest>;

 private:
  struct __isset {
    bool key;
    bool exptime;
    bool flags;
    bool value;
  } __isset = {};

  facebook::memcache::thrift::McPrependRequest underlyingThriftStruct_;
};

class McPrependReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 30;

  McPrependReply() = default;
  McPrependReply(const McPrependReply&) = default;
  McPrependReply& operator=(const McPrependReply&) = default;
  McPrependReply(McPrependReply&&) = default;
  McPrependReply& operator=(McPrependReply&&) = default;
  explicit McPrependReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McPrependReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McPrependReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McPrependReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McPrependReply underlyingThriftStruct_;
};

class McTouchReply;

class McTouchRequest : public carbon::RequestCommon {
 public:
  using reply_type = McTouchReply;

  static constexpr size_t typeId = 31;
  static constexpr const char* name = "touch";

  McTouchRequest() = default;
  McTouchRequest(const McTouchRequest&) = default;
  McTouchRequest& operator=(const McTouchRequest&) = default;
  McTouchRequest(McTouchRequest&&) = default;
  McTouchRequest& operator=(McTouchRequest&&) = default;
  explicit McTouchRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McTouchRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  const facebook::memcache::thrift::McTouchRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McTouchRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McTouchRequest>;

 private:
  struct __isset {
    bool key;
    bool exptime;
  } __isset = {};

  facebook::memcache::thrift::McTouchRequest underlyingThriftStruct_;
};

class McTouchReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 32;

  McTouchReply() = default;
  McTouchReply(const McTouchReply&) = default;
  McTouchReply& operator=(const McTouchReply&) = default;
  McTouchReply(McTouchReply&&) = default;
  McTouchReply& operator=(McTouchReply&&) = default;
  explicit McTouchReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McTouchReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McTouchReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McTouchReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McTouchReply underlyingThriftStruct_;
};

class McFlushReReply;

class McFlushReRequest : public carbon::RequestCommon {
 public:
  using reply_type = McFlushReReply;

  static constexpr size_t typeId = 41;
  static constexpr const char* name = "flushre";

  McFlushReRequest() = default;
  McFlushReRequest(const McFlushReRequest&) = default;
  McFlushReRequest& operator=(const McFlushReRequest&) = default;
  McFlushReRequest(McFlushReRequest&&) = default;
  McFlushReRequest& operator=(McFlushReRequest&&) = default;
  explicit McFlushReRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McFlushReRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  const facebook::memcache::thrift::McFlushReRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McFlushReRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McFlushReRequest>;

 private:
  struct __isset {
    bool key;
  } __isset = {};

  facebook::memcache::thrift::McFlushReRequest underlyingThriftStruct_;
};

class McFlushReReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 42;

  McFlushReReply() = default;
  McFlushReReply(const McFlushReReply&) = default;
  McFlushReReply& operator=(const McFlushReReply&) = default;
  McFlushReReply(McFlushReReply&&) = default;
  McFlushReReply& operator=(McFlushReReply&&) = default;
  explicit McFlushReReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McFlushReReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McFlushReReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McFlushReReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McFlushReReply underlyingThriftStruct_;
};

class McFlushAllReply;

class McFlushAllRequest : public carbon::RequestCommon {
 public:
  using reply_type = McFlushAllReply;

  static constexpr size_t typeId = 43;
  static constexpr const char* name = "flushall";

  McFlushAllRequest() = default;
  McFlushAllRequest(const McFlushAllRequest&) = default;
  McFlushAllRequest& operator=(const McFlushAllRequest&) = default;
  McFlushAllRequest(McFlushAllRequest&&) = default;
  McFlushAllRequest& operator=(McFlushAllRequest&&) = default;
  explicit McFlushAllRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McFlushAllRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   delay_ref() const& {
    return underlyingThriftStruct_.delay_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   delay_ref() & {
    return underlyingThriftStruct_.delay_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   delay_ref() && {
    return std::move(underlyingThriftStruct_).delay_ref();
  }
  
  const facebook::memcache::thrift::McFlushAllRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McFlushAllRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McFlushAllRequest>;

 private:
  struct __isset {
    bool key;
    bool delay;
  } __isset = {};

  facebook::memcache::thrift::McFlushAllRequest underlyingThriftStruct_;
};

class McFlushAllReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 44;

  McFlushAllReply() = default;
  McFlushAllReply(const McFlushAllReply&) = default;
  McFlushAllReply& operator=(const McFlushAllReply&) = default;
  McFlushAllReply(McFlushAllReply&&) = default;
  McFlushAllReply& operator=(McFlushAllReply&&) = default;
  explicit McFlushAllReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McFlushAllReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McFlushAllReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McFlushAllReply>;

 private:
  struct __isset {
    bool result;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McFlushAllReply underlyingThriftStruct_;
};

class McGatReply;

class McGatRequest : public carbon::RequestCommon {
 public:
  using reply_type = McGatReply;

  static constexpr size_t typeId = 45;
  static constexpr const char* name = "gat";

  McGatRequest() = default;
  McGatRequest(const McGatRequest&) = default;
  McGatRequest& operator=(const McGatRequest&) = default;
  McGatRequest(McGatRequest&&) = default;
  McGatRequest& operator=(McGatRequest&&) = default;
  explicit McGatRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McGatRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  const facebook::memcache::thrift::McGatRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McGatRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McGatRequest>;

 private:
  struct __isset {
    bool exptime;
    bool key;
  } __isset = {};

  facebook::memcache::thrift::McGatRequest underlyingThriftStruct_;
};

class McGatReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 46;

  McGatReply() = default;
  McGatReply(const McGatReply&) = default;
  McGatReply& operator=(const McGatReply&) = default;
  McGatReply(McGatReply&&) = default;
  McGatReply& operator=(McGatReply&&) = default;
  explicit McGatReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::optional_field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McGatReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McGatReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McGatReply>;

 private:
  struct __isset {
    bool result;
    bool value;
    bool flags;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McGatReply underlyingThriftStruct_;
};

class McGatsReply;

class McGatsRequest : public carbon::RequestCommon {
 public:
  using reply_type = McGatsReply;

  static constexpr size_t typeId = 47;
  static constexpr const char* name = "gats";

  McGatsRequest() = default;
  McGatsRequest(const McGatsRequest&) = default;
  McGatsRequest& operator=(const McGatsRequest&) = default;
  McGatsRequest(McGatsRequest&&) = default;
  McGatsRequest& operator=(McGatsRequest&&) = default;
  explicit McGatsRequest(folly::StringPiece sp) {
    underlyingThriftStruct_.key = sp;
  }
  explicit McGatsRequest(folly::IOBuf&& carbonKey) {
    underlyingThriftStruct_.key = std::move(carbonKey);
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const int32_t&>
   exptime_ref() const& {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&>
   exptime_ref() & {
    return underlyingThriftStruct_.exptime_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int32_t&&>
   exptime_ref() && {
    return std::move(underlyingThriftStruct_).exptime_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Keys<folly::IOBuf>&>
   key_ref() const& {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&>
   key_ref() & {
    return underlyingThriftStruct_.key_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Keys<folly::IOBuf>&&>
   key_ref() && {
    return std::move(underlyingThriftStruct_).key_ref();
  }
  
  const facebook::memcache::thrift::McGatsRequest& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McGatsRequest& getThriftStruct() {
    markBufferAsDirty();
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McGatsRequest>;

 private:
  struct __isset {
    bool exptime;
    bool key;
  } __isset = {};

  facebook::memcache::thrift::McGatsRequest underlyingThriftStruct_;
};

class McGatsReply : public carbon::ReplyCommon {
 public:

  static constexpr size_t typeId = 48;

  McGatsReply() = default;
  McGatsReply(const McGatsReply&) = default;
  McGatsReply& operator=(const McGatsReply&) = default;
  McGatsReply(McGatsReply&&) = default;
  McGatsReply& operator=(McGatsReply&&) = default;
  explicit McGatsReply(carbon::Result carbonResult) {
    underlyingThriftStruct_.result = carbonResult;
  }

  FOLLY_ERASE ::apache::thrift::field_ref<const carbon::Result&>
   result_ref() const& {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&>
   result_ref() & {
    return underlyingThriftStruct_.result_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<carbon::Result&&>
   result_ref() && {
    return std::move(underlyingThriftStruct_).result_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   casToken_ref() const& {
    return underlyingThriftStruct_.casToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   casToken_ref() & {
    return underlyingThriftStruct_.casToken_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   casToken_ref() && {
    return std::move(underlyingThriftStruct_).casToken_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::optional_field_ref<const folly::IOBuf&>
   value_ref() const& {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&>
   value_ref() & {
    return underlyingThriftStruct_.value_ref();
  }
  FOLLY_ERASE ::apache::thrift::optional_field_ref<folly::IOBuf&&>
   value_ref() && {
    return std::move(underlyingThriftStruct_).value_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const uint64_t&>
   flags_ref() const& {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&>
   flags_ref() & {
    return underlyingThriftStruct_.flags_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<uint64_t&&>
   flags_ref() && {
    return std::move(underlyingThriftStruct_).flags_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const std::string&>
   message_ref() const& {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&>
   message_ref() & {
    return underlyingThriftStruct_.message_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<std::string&&>
   message_ref() && {
    return std::move(underlyingThriftStruct_).message_ref();
  }
  
  FOLLY_ERASE ::apache::thrift::field_ref<const int16_t&>
   appSpecificErrorCode_ref() const& {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&>
   appSpecificErrorCode_ref() & {
    return underlyingThriftStruct_.appSpecificErrorCode_ref();
  }
  FOLLY_ERASE ::apache::thrift::field_ref<int16_t&&>
   appSpecificErrorCode_ref() && {
    return std::move(underlyingThriftStruct_).appSpecificErrorCode_ref();
  }
  
  const facebook::memcache::thrift::McGatsReply& getThriftStruct() const {
    return underlyingThriftStruct_;
  }
  facebook::memcache::thrift::McGatsReply& getThriftStruct() {
    return underlyingThriftStruct_;
  }

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  // Methods for Thrift interoperability, note that the methods work with Thrift
  // protocols and not Carbon protocol.
  void __clear() {
    underlyingThriftStruct_.__clear();
  }
  template <class Protocol>
  uint32_t write(Protocol* protocol) const {
    return underlyingThriftStruct_.write(protocol);
  }
  template <class Protocol>
  uint32_t serializedSize(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSize(protocol);
  }
  template <class Protocol>
  uint32_t serializedSizeZC(Protocol* protocol) const {
    return underlyingThriftStruct_.serializedSizeZC(protocol);
  }
 private:
  template <class Protocol>
  void readNoXfer(Protocol* protocol) {
    underlyingThriftStruct_.read(protocol);
  }

  friend class apache::thrift::Cpp2Ops<McGatsReply>;

 private:
  struct __isset {
    bool result;
    bool casToken;
    bool value;
    bool flags;
    bool message;
    bool appSpecificErrorCode;
  } __isset = {};

  facebook::memcache::thrift::McGatsReply underlyingThriftStruct_;
};
} // namespace memcache
} // namespace facebook

#include "MemcacheMessages-inl.h"
